"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var path_1 = tslib_1.__importDefault(require("path"));
var ora_1 = tslib_1.__importDefault(require("ora"));
var fs_extra_1 = tslib_1.__importDefault(require("fs-extra"));
var package_const_1 = require("../../shared/constants/package.const");
var utils_1 = require("../../shared/utils");
var messages_1 = require("../../shared/messages");
var setup_1 = require("../../setup");
exports.independencyBinCommand = function (prog) {
    prog
        .command('migration independency')
        .describe('Add all necessary settings to the package so that it can function outside of the workspace')
        .example('migration independency')
        .action(function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var _a, failed, generating, successful, bootSpinner, workspacePackage, packageJsonPath, packageJson, err_1;
        return tslib_1.__generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _a = new messages_1.IndependencyMessages(), failed = _a.failed, generating = _a.generating, successful = _a.successful;
                    bootSpinner = ora_1.default(generating());
                    return [4 /*yield*/, utils_1.findWorkspacePackageDir()];
                case 1:
                    workspacePackage = _b.sent();
                    packageJsonPath = path_1.default.resolve(workspacePackage, package_const_1.PACKAGE_JSON);
                    return [4 /*yield*/, fs_extra_1.default.readJSON(packageJsonPath)];
                case 2:
                    packageJson = (_b.sent());
                    bootSpinner.start();
                    _b.label = 3;
                case 3:
                    _b.trys.push([3, 6, , 7]);
                    return [4 /*yield*/, fs_extra_1.default.copy(path_1.default.resolve(__dirname, '../../../../templates/migration/independency'), workspacePackage, { overwrite: true, errorOnExist: false })];
                case 4:
                    _b.sent();
                    return [4 /*yield*/, fs_extra_1.default.outputJSON(packageJsonPath, tslib_1.__assign(tslib_1.__assign({}, packageJson), setup_1.migrationSetup.independency), { spaces: 2 })];
                case 5:
                    _b.sent();
                    utils_1.installDependencies();
                    bootSpinner.succeed(successful());
                    return [3 /*break*/, 7];
                case 6:
                    err_1 = _b.sent();
                    bootSpinner.fail(failed());
                    utils_1.logError(err_1);
                    process.exit(1);
                    return [3 /*break*/, 7];
                case 7: return [2 /*return*/];
            }
        });
    }); });
};
