"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var path_1 = tslib_1.__importDefault(require("path"));
var fs_extra_1 = tslib_1.__importDefault(require("fs-extra"));
var rollup_1 = require("rollup");
var messages_1 = require("../../shared/messages");
var build_config_1 = require("../../configs/build.config");
var utils_1 = require("../../shared/utils");
exports.buildBinCommand = function (prog) {
    prog
        .command('build')
        .describe('Build a package.')
        // eslint-disable-next-line @typescript-eslint/ban-ts-ignore
        // @ts-ignore
        .alias('b')
        .example('build')
        .action(function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var time, _a, bundling, successful, packagePath, packageJsonPath, tsconfigJsonPath, packageJson, tsconfigJson, buildConfig, bundle, duration;
        return tslib_1.__generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    time = process.hrtime();
                    _a = new messages_1.BuildMessages(), bundling = _a.bundling, successful = _a.successful;
                    return [4 /*yield*/, utils_1.findWorkspacePackageDir()];
                case 1:
                    packagePath = _b.sent();
                    packageJsonPath = path_1.default.resolve(packagePath, 'package.json');
                    tsconfigJsonPath = path_1.default.resolve(packagePath, 'tsconfig.json');
                    return [4 /*yield*/, fs_extra_1.default.readJSON(packageJsonPath)];
                case 2:
                    packageJson = (_b.sent());
                    return [4 /*yield*/, fs_extra_1.default.readJSON(tsconfigJsonPath)];
                case 3:
                    tsconfigJson = (_b.sent());
                    buildConfig = build_config_1.createBuildConfig({
                        tsconfigJson: tsconfigJson,
                        packageJson: packageJson,
                        displayFilesize: true,
                        runEslint: true,
                        useClosure: false
                    });
                    return [4 /*yield*/, utils_1.cleanDistFolder()];
                case 4:
                    _b.sent();
                    console.log(bundling(packageJson));
                    return [4 /*yield*/, rollup_1.rollup(buildConfig)];
                case 5:
                    bundle = _b.sent();
                    return [4 /*yield*/, bundle.write(buildConfig.output)];
                case 6:
                    _b.sent();
                    duration = process.hrtime(time);
                    console.log(successful(duration));
                    return [2 /*return*/];
            }
        });
    }); });
};
